# RPi_WS2812b_LED

#Raspberry Pi Project
#WS2812b - LED
#Python3

Objective: 

Be able to pass through data (text, designs, colors, patterns, etc) through GPIO on a Raspberry Pi, through to WS2812b LEDs.

Initial Challenges:

1 - Rasberry Pi doesn't have 1:1 libraries for Neopixel, so need to write programs to pass off to the Adafruit libraries (already installed)

2 - Current LEDs are in a "zigzag" configuration (because we can not use the 1:1 Neopixel Matrix Module), we have to take on the overhead to configure/define our LED matrix, then convert our data to that matrix
Example: LED Matrix numbered by: 8x8


    0 | 15 | 16 | 31 | 32 | 47 | 48 | 63 |
    1 | 14 | 17 | 30 | 33 | 46 | 49 | 62 |
    2 | 13 | 18 | 29 | 34 | 45 | 50 | 61 |
    3 | 12 | 19 | 28 | 35 | 44 | 51 | 60 |
    4 | 11 | 20 | 27 | 36 | 43 | 52 | 59 |
    5 | 10 | 21 | 26 | 37 | 42 | 53 | 58 |
    6 | 9  | 22 | 25 | 38 | 41 | 54 | 57 |
    7 | 8  | 23 | 24 | 39 | 40 | 55 | 56 |

    vs

    0  | 1  | 2  | 3  | 4  | 5  | 6  | 7 
    15 | 14 | 13 | 12 | 11 | 10 | 9  | 8
    16 | 17 | 18 | 19 | 20 | 21 | 22 | 23
    31 | 30 | 29 | 28 | 27 | 26 | 25 | 24
    32 | 33 | 34 | 35 | 36 | 37 | 38 | 39
    47 | 46 | 45 | 44 | 43 | 42 | 41 | 40
    48 | 49 | 50 | 51 | 52 | 53 | 54 | 55
    63 | 62 | 61 | 60 | 59 | 58 | 57 | 56

3 - Read from a file > take the contents > convert to string > turn string into ASCII imagery > turn ASCII imagery into pixel grid matrix > convert matrix into zigzag matrix to send to Neopixel and throw it to the LED matrix. (piltest.py) already has this PoC up to the Matrix to zigzag.

4 - Figure out how to use Neopixel pass offs. (already solved and confirmed working)